#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: INITCONFIG-lib.pl,v 1.2 2003/03/03 14:11:11 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our system subroutines and &init_config().
  do "../web-lib.pl";
  &init_config();

  ### ##########################################################################
  ### Global Variables
  ### ##########################################################################
  $CHKCONFIG_BIN     =  '/sbin/chkconfig';
  $IPCALC_BIN        =  '/bin/ipcalc';
  $LOCALE_DIRECTORY  =  '/usr/share/zoneinfo';

  @LOCALE_ZONES      =  ("Africa", "America",  "Antarctica", "Arctic",
                         "Asia",   "Atlantic", "Australia",  "Brazil",
                         "Canada", "Chile",    "China",      "Europe",
                         "Indian", "Mexico",   "Mideast",    "Pacific", "US");

  @SERVICES = (

                { 'name' => 'Firewalling',
                  'port' => 'FIR',
                  'init' => 'iptables' },

                { 'name' => 'FTP Server',
                  'port' => 'ftp',
                  'init' => 'xinetd' },

                { 'name' => 'DHCP Server',
                  'port' => 'bootps',
                  'init' => 'dhcpd' },

                { 'name' => 'Web Server',
                  'port' => 'www',
                  'init' => 'httpd' },

                { 'name' => 'Domain Name Server',
                  'port' => 'domain',
                  'init' => 'named' },

                { 'name' => 'Mail Server',
                  'port' => 'smtp',
                  'init' => 'postfix' },

                { 'name' => 'PPTP Server',
                  'port' => '1723',
                  'init' => 'pptpd' },

                { 'name' => 'Windows File Sharing',
                  'port' => 'netbios-ns',
                  'init' => 'samba' },

                { 'name' => 'SIMAP Server',
                  'port' => 'simap',
                  'init' => 'stunnel-imap' },

                { 'name' => 'SPOP3 Server',
                  'port' => 'spop3',
                  'init' => 'stunnel-pop3' },

                { 'name' => 'User Password Changer',
                  'port' => '1022',
                  'init' => 'userpass' },
              );

  @NTP_SERVERS = (
                   { 'name'    => "wwv.otc.psu.edu",
                     'address' => "128.118.46.3",
                     'region'  => "USA" },

                   { 'name'    => "lerc-dns.lerc.nasa.gov",
                     'address' => "128.156.1.43",
                     'region'  => "USA" },

                   { 'name'    => "navobs1.wustl.edu",
                     'address' => "128.252.19.1",
                     'region'  => "USA" },

                   { 'name'    => "timekeeper.isi.edu",
                     'address' => "128.9.176.30",
                     'region'  => "USA" },

                   { 'name'    => "swisstime.ethz.ch",
                     'address' => "129.132.2.21",
                     'region'  => "CH" },

                   { 'name'    => "clock.osf.org",
                     'address' => "130.105.4.59",
                     'region'  => "USA" },

                   { 'name'    => "ntps1-0.cs.tu-berlin.de",
                     'address' => "130.149.17.21",
                     'region'  => "DE" },

                   { 'name'    => "ntps1-1.cs.tu-berlin.de",
                     'address' => "130.149.17.8",
                     'region'  => "DE" },

                   { 'name'    => "ntp.nml.csiro.au",
                     'address' => "130.155.98.1",
                     'region'  => "AU" },

                   { 'name'    => "ntp.per.nml.csiro.au",
                     'address' => "130.95.156.206",
                     'region'  => "AU" },

                   { 'name'    => "ntps1-1.rz.Uni-Osnabrueck.DE",
                     'address' => "131.173.17.7",
                     'region'  => "DE" },

                   { 'name'    => "ntp2.fau.de",
                     'address' => "131.188.34.107",
                     'region'  => "DE" },

                   { 'name'    => "ntp1.fau.de",
                     'address' => "131.188.34.45",
                     'region'  => "DE" },

                   { 'name'    => "ntp0.fau.de",
                     'address' => "131.188.34.75",
                     'region'  => "DE" },

                   { 'name'    => "clock.tl.fukuoka-u.ac.jp",
                     'address' => "133.100.11.8",
                     'region'  => "JP" },

                   { 'name'    => "clock.nc.fukuoka-u.ac.jp",
                     'address' => "133.100.9.2",
                     'region'  => "JP" },

                   { 'name'    => "clock.cuhk.edu.hk",
                     'address' => "137.189.6.18",
                     'region'  => "HK" },

                   { 'name'    => "ntp.mel.nml.CSIRO.AU",
                     'address' => "138.194.21.154",
                     'region'  => "AU" },

                   { 'name'    => "ntp1.connectiv.com",
                     'address' => "138.39.7.20",
                     'region'  => "USA" },

                   { 'name'    => "ntp-sop.inria.fr",
                     'address' => "138.96.64.10",
                     'region'  => "FR" },

                   { 'name'    => "ntp.marine.csiro.au",
                     'address' => "140.79.17.101",
                     'region'  => "AU" },

                   { 'name'    => "ntp.dgf.uchile.cl",
                     'address' => "146.83.8.200",
                     'region'  => "CL" },

                   { 'name'    => "tempo.cstv.to.cnr.it",
                     'address' => "150.145.33.1",
                     'region'  => "IT" },

                   { 'name'    => "vega.cbk.poznan.pl",
                     'address' => "150.254.183.15",
                     'region'  => "PL" },

                   { 'name'    => "bonehed.lcs.mit.edu",
                     'address' => "18.26.4.105",
                     'region'  => "USA" },

                   { 'name'    => "time1.stupi.se",
                     'address' => "192.36.143.150",
                     'region'  => "SE" },

                   { 'name'    => "time2.stupi.se",
                     'address' => "192.36.143.151",
                     'region'  => "SE" },

                   { 'name'    => "tick.usno.navy.mil",
                     'address' => "192.5.41.40",
                     'region'  => "USA" },

                   { 'name'    => "tock.usno.navy.mil",
                     'address' => "192.5.41.41",
                     'region'  => "USA" },

                   { 'name'    => "clock.isc.org",
                     'address' => "192.5.5.250",
                     'region'  => "USA" },

                   { 'name'    => "ntp-cup.external.hp.com",
                     'address' => "192.6.38.127",
                     'region'  => "USA" },

                   { 'name'    => "canon.inria.fr",
                     'address' => "192.93.2.20",
                     'region'  => "FR" },

                   { 'name'    => "time.ien.it",
                     'address' => "193.204.114.1",
                     'region'  => "IT" },

                   { 'name'    => "ntp0.nl.net",
                     'address' => "193.67.79.202",
                     'region'  => "NL" },

                   { 'name'    => "ntp1.nl.net",
                     'address' => "193.79.237.14",
                     'region'  => "NL" },

                   { 'name'    => "ntp2.nl.net",
                     'address' => "193.79.237.30",
                     'region'  => "NL" },

                   { 'name'    => "ptbtime1.ptb.de",
                     'address' => "194.95.250.35",
                     'region'  => "DE" },

                   { 'name'    => "ptbtime2.ptb.de",
                     'address' => "194.95.250.36",
                     'region'  => "DE" },

                   { 'name'    => "ntp.cesnet.cz",
                     'address' => "195.113.144.201",
                     'region'  => "CZ" },

                   { 'name'    => "usno.pa-x.dec.com",
                     'address' => "204.123.2.72",
                     'region'  => "USA" },

                   { 'name'    => "navobs1.usnogps.navy.mil",
                     'address' => "204.34.198.40",
                     'region'  => "USA" },

                   { 'name'    => "navobs2.usnogps.navy.mil",
                     'address' => "204.34.198.41",
                     'region'  => "USA" },

                   { 'name'    => "clock.via.net",
                     'address' => "209.81.9.7",
                     'region'  => "USA" },

                 
                   ###  Stratum 2 servers.  ###
                   { 'name'    => "tock.utoronto.ca",
                     'address' => "128.100.100.128",
                     'region'  => "CA" },

                   { 'name'    => "tick.utoronto.ca",
                     'address' => "128.100.103.252",
                     'region'  => "CA" },

                   { 'name'    => "ns.nts.umn.edu",
                     'address' => "128.101.101.101",
                     'region'  => "USA" },

                   { 'name'    => "ntp3.cs.wisc.edu",
                     'address' => "128.105.37.11",
                     'region'  => "USA" },

                   { 'name'    => "ntp1.cs.wisc.edu",
                     'address' => "128.105.39.11",
                     'region'  => "USA" },

                   { 'name'    => "clock.psu.edu",
                     'address' => "128.118.25.3",
                     'region'  => "USA" },

                   { 'name'    => "louie.udel.edu",
                     'address' => "128.175.1.3",
                     'region'  => "USA" },

                   { 'name'    => "time.deakin.edu.au",
                     'address' => "128.184.1.1",
                     'region'  => "AU" },

                   { 'name'    => "everest.cclabs.missouri.edu",
                     'address' => "128.206.206.12",
                     'region'  => "USA" },

                   { 'name'    => "ntp.tmc.edu",
                     'address' => "128.249.1.10",
                     'region'  => "USA" },

                   { 'name'    => "sundial.columbia.edu",
                     'address' => "128.59.35.142",
                     'region'  => "USA" },

                   { 'name'    => "ntp.cox.smu.edu",
                     'address' => "129.119.80.126",
                     'region'  => "USA" },

                   { 'name'    => "augean.eleceng.adelaide.edu.au",
                     'address' => "129.127.28.4",
                     'region'  => "AU" },

                   { 'name'    => "ntp.adelaide.edu.au",
                     'address' => "129.127.40.3",
                     'region'  => "AU" },

                   { 'name'    => "constellation.ecn.uoknor.edu",
                     'address' => "129.15.22.8",
                     'region'  => "USA" },

                   { 'name'    => "fartein.ifi.uio.no",
                     'address' => "129.240.64.3",
                     'region'  => "NO" },

                   { 'name'    => "ntp-1.cso.uiuc.edu",
                     'address' => "130.126.24.24",
                     'region'  => "USA" },

                   { 'name'    => "ntp-2.cso.uiuc.edu",
                     'address' => "130.126.24.44",
                     'region'  => "USA" },

                   { 'name'    => "ntp-0.cso.uiuc.edu",
                     'address' => "130.126.24.53",
                     'region'  => "USA" },

                   { 'name'    => "clock.netcetera.dk",
                     'address' => "130.228.230.2",
                     'region'  => "DK" },

                   { 'name'    => "ntp2a.mcc.ac.uk",
                     'address' => "130.88.202.49",
                     'region'  => "UK" },

                   { 'name'    => "ntp2d.mcc.ac.uk",
                     'address' => "130.88.203.12",
                     'region'  => "UK" },

                   { 'name'    => "cuckoo.nevada.edu",
                     'address' => "131.216.1.101",
                     'region'  => "USA" },

                   { 'name'    => "tick.cs.unlv.edu",
                     'address' => "131.216.22.15",
                     'region'  => "USA" },

                   { 'name'    => "tock.cs.unlv.edu",
                     'address' => "131.216.22.17",
                     'region'  => "USA" },

                   { 'name'    => "ntp.ucsd.edu",
                     'address' => "132.239.254.49",
                     'region'  => "USA" },

                   { 'name'    => "time.nrc.ca",
                     'address' => "132.246.168.148",
                     'region'  => "CA" },

                   { 'name'    => "ntp.univ-lyon1.fr",
                     'address' => "134.214.100.6",
                     'region'  => "FR" },

                   { 'name'    => "nss.nts.umn.edu",
                     'address' => "134.84.84.84",
                     'region'  => "USA" },

                   { 'name'    => "ntp.cpsc.ucalgary.ca",
                     'address' => "136.159.2.1",
                     'region'  => "CA" },

                   { 'name'    => "ntp.cmr.gov",
                     'address' => "140.162.8.3",
                     'region'  => "USA" },

                   { 'name'    => "ntp-2.mcs.anl.gov",
                     'address' => "140.221.9.6",
                     'region'  => "USA" },

                   { 'name'    => "timelord.uregina.ca",
                     'address' => "142.3.100.15",
                     'region'  => "CA" },

                   { 'name'    => "ntp.cs.unp.ac.za",
                     'address' => "143.128.82.200",
                     'region'  => "ZA" },

                   { 'name'    => "time.kfki.hu",
                     'address' => "148.6.0.1",
                     'region'  => "HU" },

                   { 'name'    => "timeserver.cs.umb.edu",
                     'address' => "158.121.104.4",
                     'region'  => "USA" },

                   { 'name'    => "zg2.ntp.carnet.hr",
                     'address' => "161.53.123.4",
                     'region'  => "HR" },

                   { 'name'    => "zg1.ntp.carnet.hr",
                     'address' => "161.53.2.70",
                     'region'  => "HR" },

                   { 'name'    => "os.ntp.carnet.hr",
                     'address' => "161.53.200.8",
                     'region'  => "HR" },

                   { 'name'    => "st.ntp.carnet.hr",
                     'address' => "161.53.30.3",
                     'region'  => "HR" },

                   { 'name'    => "ri.ntp.carnet.hr",
                     'address' => "161.53.40.3",
                     'region'  => "HR" },

                   { 'name'    => "ntp5.tamu.edu",
                     'address' => "165.91.52.110",
                     'region'  => "USA" },

                   { 'name'    => "calvus.rzs-hm.si",
                     'address' => "193.2.208.16",
                     'region'  => "SI" },

                   { 'name'    => "time.ijs.si",
                     'address' => "193.2.4.6",
                     'region'  => "SI" },

                   { 'name'    => "sizif.mf.uni-lj.si",
                     'address' => "193.2.69.15",
                     'region'  => "SI" },

                   { 'name'    => "sign.chg.ru",
                     'address' => "193.233.46.10",
                     'region'  => "RU" },

                   { 'name'    => "ntp.psn.ru",
                     'address' => "194.149.67.130",
                     'region'  => "RU" },

                   { 'name'    => "clock2.netcetera.dk",
                     'address' => "194.192.207.9",
                     'region'  => "DK" },

                   { 'name'    => "tick.keso.fi",
                     'address' => "194.215.108.15",
                     'region'  => "FI" },

                   { 'name'    => "tock.keso.fi",
                     'address' => "194.215.108.18",
                     'region'  => "FI" },

                   { 'name'    => "tick.tanac.net",
                     'address' => "195.112.34.51",
                     'region'  => "UK" },

                   { 'name'    => "ntps.net4u.it",
                     'address' => "195.32.52.129",
                     'region'  => "IT" },

                   { 'name'    => "ntp-2.vt.edu",
                     'address' => "198.82.161.227",
                     'region'  => "USA" },

                   { 'name'    => "ntp-1.vt.edu",
                     'address' => "198.82.162.213",
                     'region'  => "USA" },

                   { 'name'    => "tock.nap.com.ar",
                     'address' => "200.49.32.1",
                     'region'  => "AR" },

                   { 'name'    => "tick.nap.com.ar",
                     'address' => "200.49.40.1",
                     'region'  => "AR" },

                   { 'name'    => "ntp.saard.net",
                     'address' => "203.21.37.18",
                     'region'  => "AU" },

                   { 'name'    => "time.esec.com.au",
                     'address' => "203.21.84.4",
                     'region'  => "AU" },

                   { 'name'    => "ntp.fnbhs.com",
                     'address' => "209.144.20.76",
                     'region'  => "USA" },

                   { 'name'    => "time.chu.nrc.ca",
                     'address' => "209.87.233.53",
                     'region'  => "CA" },

                   { 'name'    => "time.sinectis.com.ar",
                     'address' => "216.244.192.3",
                     'region'  => "AR" },
                 );


  ### ##########################################################################
  sub ListLocales() {
    my (@L);

    foreach my $l (sort `find $LOCALE_DIRECTORY/$_[0] -type f`) {
      chomp $l;

      next if (($l =~ m/posix/) || ($l =~ m/right/) || ($l =~ m/SystemV/) ||
               ($l =~ m/Etc/)   || ($l =~ m/\.tab$/));

      push @L, $l;
    }

    return @L;
  }


  ### ##########################################################################
  sub isServiceActive() {
    my ($tmp);

    ($tmp) = (`chkconfig --list $_[0]` =~ m/\s+3\:([onf]+)/);
 
    if ($tmp eq "on") { return 1; } 
    else              { return 0; }
  }


  ### ##########################################################################
  sub isIP() {
    if ($_[0] =~ (m/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$/)) {
      return 1;
    }

    return 0;
  }


  ### ##########################################################################
  sub GetInterfaces() {
    my (@addresses, $IN_IFACE, $IS_VIRT, $tmp_iface);

    $IN_IFACE   =  0;
    $IS_VIRT    =  0;
    $tmp_iface  =  "";

    open IFCONFIG, "/sbin/ifconfig |";
      while (<IFCONFIG>)
      {
        chomp $_;

        if ($_ =~ m/^(eth[0-9\:]+)\s+/) {
          $IN_IFACE  =  1; $tmp_iface = $1;
          $IS_VIRT   =  1 if ($tmp_iface =~ m/\:/);
        }
        elsif ($_ eq "")  { $IN_IFACE = 0; $IS_VIRT = 0; $tmp_iface = ""; }

        if (($_ =~ m/^\s+inet\ addr\:([0-9\.]+).*Mask\:([0-9\.]+)$/) &&
            $IN_IFACE) {
          push @addresses, { 'iface'   => $tmp_iface,
                             'address' => $1,
                             'netmask' => $2,
                             'virtual' => $IS_VIRT };
        }
    }
    close IFCONFIG;

    return @addresses;
  }


  ### ##########################################################################
  sub GetNetworkNumber() {
    my ($rv, $tmp);  $rv = undef;

    $rv = `$IPCALC_BIN --network $_[0] $_[1]`; chomp $rv; $rv =~ s/^NETWORK\=//;

    return $rv;
  }


  ### ##########################################################################
  sub NumInterfaces() {
    my ($rv); $rv = 0;

    foreach my $i (&GetInterfaces()) {
      next if ($i->{'virtual'});
      $rv++;
    }

    return $rv;
  }
  ### ##########################################################################
  sub EncryptPassword() {
    use MD5;

    my ($passwd, $magic, $salt, $ctx, $ctx1, $final);
    my ($j, $i, $l, $rv, @final);

    $passwd  =  $_[0];
    $magic   =  '$1$';
    $salt    =  substr(time(), -8);
    $ctx     =  new MD5;
    $j       =  0;

    ### Add the password, magic and salt
    $ctx->add($passwd);
    $ctx->add($magic);
    $ctx->add($salt);

    ### Add some more stuff from the hash of the password and salt
    $ctx1 = new MD5;
    $ctx1->add($passwd);
    $ctx1->add($salt);
    $ctx1->add($passwd);

    ###  Finally, digest it.
    $final = $ctx1->digest();


    ###  Man this md5 stuff is a PITA...
    for (my $pl = length($passwd); $pl > 0; $pl -= 16) {
      $ctx->add($pl > 16 ? $final : substr($final, 0, $pl));
    }


    ### This piece of code seems rather pointless, but it's in the C code that
    ### does MD5 in PAM so it has to go in!
    for ($i = length($passwd); $i; $i >>= 1) {
      if ($i & 1) { $ctx->add("\0"); }
      else { $ctx->add(substr($passwd, $j, 1)); }
    }

    ###  Re-digest.
    $final = $ctx->digest();

    ### This loop exists only to waste time
    for ($i = 0; $i<1000; $i++) {
      $ctx1 = new MD5;
      $ctx1->add($i & 1 ? $passwd : $final);
      $ctx1->add($salt) if ($i % 3);
      $ctx1->add($passwd) if ($i % 7);
      $ctx1->add($i & 1 ? $final : $passwd);
      $final = $ctx1->digest();
    }

    ### Convert the 16-byte final string into a readable form
    $rv = $magic.$salt.'$';

    @final = map { ord($_) } split(//, $final);
    $l = ($final[ 0]<<16) + ($final[ 6]<<8) + $final[12];
    $rv .= &to64($l, 4);
    $l = ($final[ 1]<<16) + ($final[ 7]<<8) + $final[13];
    $rv .= &to64($l, 4);
    $l = ($final[ 2]<<16) + ($final[ 8]<<8) + $final[14];
    $rv .= &to64($l, 4);

    $l = ($final[ 3]<<16) + ($final[ 9]<<8) + $final[15];
    $rv .= &to64($l, 4);
    $l = ($final[ 4]<<16) + ($final[10]<<8) + $final[ 5];
    $rv .= &to64($l, 4);
    $l = $final[11];
    $rv .= &to64($l, 2);

    return $rv;
  }


  ### ##########################################################################
  sub to64 {
    my (@itoa64, $v, $n, $r);

    @itoa64 = split(//, "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz");

    ($v, $n) = @_;

    while(--$n >= 0) { $r .= $itoa64[$v & 0x3f]; $v >>= 6; }

    return $r;
  }


  ### ##########################################################################
  sub ListNTPServers() {
    my ($rv);

    $rv  =  "<SELECT NAME=\"$_[0]\">\n";
    $rv .=  "  <OPTION VALUE=\"NULL\">Please Select or Enter</OPTION>\n";

    foreach my $s (sort ntpsort @NTP_SERVERS) {
      $rv .= "  <OPTION VALUE=\"$s->{'name'}\">$s->{'name'} ($s->{'region'})</OPTION>\n";
    }

    $rv .=  "</SELECT>\n";

    return $rv;
  }


  ### ##########################################################################
  sub isXinetdServiceActive() {
    my ($lref, $rv); $rv = "";

    open XINETD_CONF, "/etc/xinetd.d/$_[0]";
      while (my $line = <XINETD_CONF>)
      {
        chomp $line;

        ###  If the "disble" line is commented out, then it is active.
        if ($line =~ m/^(.*)disable\s+\=/) {
          if ($1 =~ m/#/) { return 1; }
          else            { return 0; }
        }
      }
    close XINETD_CONF;

    ###  If we have gotten this far, then it's not disabled.  It's active.
    return 1;
  }


  ### ##########################################################################
  sub toggleXinetdService() {
    my ($lref, $rc);

    $lref = &read_file_lines("/etc/xinetd.d//$_[0]");

    ###  Comment out the "disable =" line if we want it enabled.
    for (my $i = 0; $i < @$lref; $i++) {
      if (@$lref[$i] =~ m/^.*disable\s+\=/) {
        if ($_[1] eq "on") { @$lref[$i] = "\t# disable\t\t= yes"; }
        else               { @$lref[$i] = "\tdisable\t\t= yes"; }
      }
    }

    &flush_file_lines();
  }


  ### ##########################################################################
  sub ntpsort() { $b->{'region'} cmp $a->{'region'} };


  ### ##########################################################################
  sub PrintError {
    my ($message) = @_;

    print <<ErrorEOF;
Content-type: text/html


<HTML>
<HEAD>
  <TITLE> </TITLE>

  <SCRIPT LANGUAGE="JavaScript">
    alert("$message");
    history.go(-1);
  </SCRIPT>
</HEAD>
</HTML>
ErrorEOF
  }


  ### ##########################################################################
  1;

