#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: do_step_01.cgi,v 1.3 2002/05/03 05:34:15 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "INITCONFIG-lib.pl";
  &ReadParse();


  if ($in{'save'}) {
    my (@H, %miniserv);

    ###
    ###  Input Validation
    ###
    if (! $in{'root1'}) {
      &PrintError("Please enter a Root Password."); exit;
    }
    elsif (! $in{'root2'}) {
      &PrintError("Please verify your Root Password."); exit;
    }
    elsif ($in{'root1'} ne $in{'root2'}) {
      &PrintError("The two Root Passwords do not match."); exit;
    }

    elsif (! $in{'webtool1'}) {
      &PrintError("Please enter a WebTool Password."); exit;
    }
    elsif (! $in{'webtool2'}) {
      &PrintError("Please verify your WebTool Password."); exit;
    }
    elsif ($in{'webtool1'} ne $in{'webtool2'}) {
      &PrintError("The two WebTool Passwords do not match."); exit;
    }

    elsif (! $in{'allow'}) {
      &PrintError("Please enter at least one Trusted Host."); exit;
    }

    foreach my $ip (split /\r\n/, $in{'allow'}) {
      if (! &isIP($ip)) {
        &PrintError("'$ip' is not a valid IP Network/Address."); exit;
      }
    }


    ###
    ###  Update root's password.
    ###
    &UpdateRootPassword($in{'root1'});


    ###
    ###  Update the WebTool/MySQL/LIDS passwords.
    ###

    &UpdateWebToolPassword($in{'webtool1'});


    ###
    ###  Update WebTool Allow Hosts.
    ###
    @H = split /\r\n/, $in{'allow'};

    &get_miniserv_config(\%miniserv);
      delete($miniserv{"allow"});
      $miniserv{"allow"} = join(' ', @H);
    &put_miniserv_config(\%miniserv);

  }


  &redirect("step_02.cgi");


  ### ##########################################################################
  sub UpdateRootPassword() {
    my ($encpass, $lref);

    $encpass  =  &EncryptPassword($_[0]);
    $lref     =  &read_file_lines("/etc/shadow");

    ###  Replace root's password with our new one.
    for (my $i = 0; $i < @$lref; $i++) {
      if (@$lref[$i] =~ m/^root\:([^\:]+)\:(.*)$/) {
        @$lref[$i] = "root:$encpass:$2";
      }
    }

    &flush_file_lines();
  }


  ### ##########################################################################
  sub UpdateWebToolPassword() {
    system "/usr/webtool/changepass.pl", "/etc/webtool", "admin", "$_[0]";
  }
