#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: do_step_02.cgi,v 1.3 2002/05/08 19:59:49 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "INITCONFIG-lib.pl";
  &ReadParse();


  if ($in{'save'}) {
    my ($LOCALE_FILE);
    my ($NTP1_n, $NTP2_n, $NTP3_n);
    my ($NTP1_a, $NTP2_a, $NTP3_a);

    $LOCALE_FILE = "$LOCALE_DIRECTORY/$in{'Directory'}/$in{'File'}";


    ###
    ###  Input Validation
    ###
    if ((! $in{'Directory'}) || ($in{'Directory'} eq "NULL")) {
      &PrintError("Please select a region."); exit;
    }
    elsif (! $in{'File'}) {
      &PrintError("Please select an area."); exit;
    }
    elsif (! -f "$LOCALE_DIRECTORY/$in{'Directory'}/$in{'File'}") {
      &PrintError("The selected locale is unavailable. Please select another.");
      exit;
    }


    elsif ( (($in{'ntpselect_1'} eq "NULL") && ! $in{'ntpinput_1'}) ||
            (($in{'ntpselect_1'} ne "NULL") && $in{'ntpinput_1'}) ) {
      &PrintError("Please either select OR enter a primary time server."); exit;
    }
    elsif ( (($in{'ntpselect_2'} eq "NULL") && ! $in{'ntpinput_2'}) ||
            (($in{'ntpselect_2'} ne "NULL") && $in{'ntpinput_2'}) ) {
      &PrintError("Please either select OR enter a secondary time server."); exit;
    }
    elsif ( (($in{'ntpselect_3'} eq "NULL") && ! $in{'ntpinput_3'}) ||
            (($in{'ntpselect_3'} ne "NULL") && $in{'ntpinput_3'}) ) {
      &PrintError("Please either select OR enter a ternary time server."); exit;
    }


    ###
    ###  Setup $NTP1_*.
    ###
    if ($in{'ntpselect_1'} ne "NULL") {
      $NTP1_n = $in{'ntpselect_1'};

      foreach my $n (@NTP_SERVERS) {
        if ($n->{'name'} eq $NTP1_n) { $NTP1_a = $n->{'address'}; }
      }
    }
    elsif ($in{'ntpinput_1'}) {
      if ($in{'ntpinput_1'} !~ m/^[A-Za-z0-9\-\.]+$/) {
        &PrintError("$in{'ntpinput_1'} is not a valid time server."); exit;
      }

      $NTP1_n = $in{'ntpinput_1'};
      $tmp = gethostbyname $NTP1_n;

      if (!$tmp) { &PrintError("Could not resolve $in{'ntpinput_1'}."); exit; }
      else       { $NTP1_a = join ".", unpack('C4', $tmp); }
    }

    ###
    ###  Setup $NTP2_*.
    ###
    if ($in{'ntpselect_2'} ne "NULL") {
      $NTP2_n = $in{'ntpselect_2'};

      foreach my $n (@NTP_SERVERS) {
        if ($n->{'name'} eq $NTP2_n) { $NTP2_a = $n->{'address'}; }
      }
    }
    elsif ($in{'ntpinput_2'}) {
      if ($in{'ntpinput_2'} !~ m/^[A-Za-z0-9\-\.]+$/) {
        &PrintError("$in{'ntpinput_2'} is not a valid time server."); exit;
      }

      $NTP2_n = $in{'ntpinput_2'};
      $tmp = gethostbyname $NTP2_n;

      if (!$tmp) { &PrintError("Could not resolve $in{'ntpinput_2'}."); exit; }
      else       { $NTP2_a = join ".", unpack('C4', $tmp); }
    }

    ###
    ###  Setup $NTP3_*.
    ###
    if ($in{'ntpselect_3'} ne "NULL") {
      $NTP3_n = $in{'ntpselect_3'};

      foreach my $n (@NTP_SERVERS) {
        if ($n->{'name'} eq $NTP3_n) { $NTP3_a = $n->{'address'}; }
      }
    }
    elsif ($in{'ntpinput_3'}) {
      if ($in{'ntpinput_3'} !~ m/^[A-Za-z0-9\-\.]+$/) {
        &PrintError("$in{'ntpinput_3'} is not a valid time server."); exit;
      }

      $NTP3_n = $in{'ntpinput_3'};
      $tmp = gethostbyname $NTP3_n;

      if (!$tmp) { &PrintError("Could not resolve $in{'ntpinput_3'}."); exit; }
      else       { $NTP3_a = join ".", unpack('C4', $tmp); }
    }


    ### ########################################################################
    ### FINALLY!  We have all our info (what a PITA).  Now write the files.
    ### ########################################################################

    ###
    ###  Write /etc/ntp.conf
    ###
    open CONF, ">/etc/ntp.conf";
      print CONF <<EOF;
server $NTP1_n
server $NTP2_n
server $NTP3_n

# Undisciplined Local Clock. This is a fake driver intended for backup
# and when no outside source of synchronized time is available. The
# default stratum is usually 3, but in this case we elect to use stratum
# 0. Since the server line does not have the prefer keyword, this driver
# is never used for synchronization, unless no other other
# synchronization source is available. In case the local host is
# controlled by some external source, such as an external oscillator or
# another protocol, the prefer keyword would cause the local host to
# disregard all other synchronization sources, unless the kernel
# modifications are in use and declare an unsynchronized condition.
#
#server 127.127.1.0     # local clock
#fudge  127.127.1.0 stratum 10



#
# Drift file.  Put this in a directory which the daemon can write to.
# No symbolic links allowed, either, since the daemon updates the file
# by creating a temporary in the same directory and then rename()'ing
# it to the file.
#
driftfile /etc/ntp/drift
multicastclient                 # listen on default 224.0.1.1
broadcastdelay  0.008

#
# Authentication delay.  If you use, or plan to use someday, the
# authentication facility you should make the programs in the auth_stuff
# directory and figure out what this number should be on your machine.
#
authenticate no

#
# Keys file.  If you want to diddle your server at run time, make a
# keys file (mode 600 for sure) and define the key number to be
# used for making requests.
# PLEASE DO NOT USE THE DEFAULT VALUES HERE. Pick your own, or remote
# systems might be able to reset your clock at will.
#
#keys           /etc/ntp/keys
#trustedkey     65535
#requestkey     65535
#controlkey     65535

# User which ntpd is to be run as.
user ntp

# Directory to chroot self to.
chroot /etc/ntp
EOF
    close CONF;


    ###
    ###  Write /etc/ntp/step-tickers.
    ###
    open TICKERS, ">/etc/ntp/step-tickers";
      print TICKERS "$NTP1_a\n";
      print TICKERS "$NTP2_a\n";
      print TICKERS "$NTP3_a\n";
    close TICKERS;


    ###
    ###  Remove the "old" locale and link the new one into place.
    ###
    unlink "/etc/localtime";
    system "ln -s $LOCALE_FILE /etc/localtime";

    # Fix localtime in Postfix chroot.
    unlink "/var/spool/postfix/etc/localtime";
    system "cp -a $LOCALE_FILE /var/spool/postfix/etc/localtime";
  }


  &redirect("step_03.cgi");
