#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: step_02.cgi,v 1.2.4.1 2003/04/10 13:55:54 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "INITCONFIG-lib.pl";


  ###  Define local variables.
  my ($ntp_SELECT_1, $ntp_SELECT_2, $ntp_SELECT_3);
  my ($ntp_1_HELP, $ntp_2_HELP, $ntp_3_HELP);

  ###  Setup local variables.
  $ntp_SELECT_1  =  &ListNTPServers("ntpselect_1");
  $ntp_SELECT_2  =  &ListNTPServers("ntpselect_2");
  $ntp_SELECT_3  =  &ListNTPServers("ntpselect_3");
  $ntp_1_HELP    =  &hlink("NTP Server #1", "ntp_server");
  $ntp_2_HELP    =  &hlink("NTP Server #2", "ntp_server");
  $ntp_3_HELP    =  &hlink("NTP Server #3", "ntp_server");


  ###  Since we're using this JS crap, we need a special header.
  print <<EOF;
Content-type: text/html

<HTML>
  <HEAD>
    <TITLE>Initial Configuration :: Locale and Time Setup (2/3)</TITLE>


    <SCRIPT LANGUAGE="JavaScript" SRC="DynamicOptionList.js">
    </SCRIPT>

    <SCRIPT LANGUAGE="JavaScript">
      var localeArea = new DynamicOptionList("File", "Directory");

      localeArea.addOptions("NULL", "<----------", "<----------");
EOF


  ###  Iterate through each zone and populate localeArea.
  foreach my $z (sort @LOCALE_ZONES) {
    print "      localeArea.addOptions(\"$z\"";

    foreach my $l (&ListLocales($z)) {
      my ($t); ($t) = ($l =~ m/^$LOCALE_DIRECTORY\/$z\/(.*)$/);

      print ", \"$t\", \"$t\"";
    }

    print ");\n";
  }


  ###  More HTML.
  print <<EOF;

      function init() {
        var theform = document.forms[0];
        localeArea.init(theform);
      }
    </SCRIPT>

    <STYLE TYPE="text/css">
      BODY { background-image: url(/images/backgrn.gif); }
      A:link    { text-decoration: none; color: #800000; }
      A:visited { text-decoration: none; color: #800000; }
      A:active  { text-decoration: none; color: #800000; }
      A:hover   { color: #CCCCCC; }
      BODY,TH,P,FONT,LI,UL,BLOCKQUOTE,A,TABLE,I { font-family: Arial, Helvetica, Sans-Serif; font-size: 10pt }
      PRE { font-family: Courier }
      .thead { font-family: Arial, Helvetica, Sans-Serif; font-size: 10pt; color: #ffffff; margin-left: 10px; }
      .ttitle { font-family: Arial, Helvetica, Sans-Serif; font-size: 14pt; color: #ffffff; margin-left: 10px; }
      .rhead { font-family: Arial, Helvetica, Sans-Serif; font-size: 10pt; color: #ffffff; margin-right: 10px; }
      .nbody { font-family: Arial, Helvetica, Sans-Serif; font-size: 10pt; margin-left: 10px; margin-right: 10px; }
      .tbody { margin-left: 10px; }
      .toolfont { font-family: Arial, Helvetica, Sans-Serif;   font-size: 10pt; }
    </STYLE>
  </HEAD>

<BODY BGCOLOR="#FFFFFF" LINK="#0000EE" VLINK="#0000EE" TEXT="#000000" onLoad="init()">
  <TABLE WIDTH="731" BORDER="0">
  <TR>
    <TD WIDTH="25">&nbsp;</td>
    <TD WIDTH="682">
      <TABLE BORDER="0" WIDTH="100%">
      <TR>
        <TD ALIGN="CENTER" WIDTH="70%">
          <IMG SRC="/images/SectionHeader-nomatch.png" USEMAP="#header" BORDER=0>
        </TD>
      </TR>
      </TABLE>
EOF



  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_step_02.cgi" METHOD="POST">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>
      Initial Configuration :: Locale and Time Setup
    </B></DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>System Locale</B></DIV></TD>
      </TR>

      <TR $cb>
        <TD COLSPAN="2"><DIV CLASS="nbody">
          Please select your timezone below.  First select a region, then
          select an area.
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR>
        <TD><DIV CLASS="toolfont">
          <SELECT NAME="Directory" onChange="localeArea.populate()">
            <OPTION VALUE="NULL">Please Select</A>
EOF


  ###  List all of the locale zones.
  foreach my $z (sort @LOCALE_ZONES) {
    print "          <OPTION VALUE=\"$z\">$z</OPTION>\n";
  }


  ###  Print the rest of the HTML.
  print <<EOF;
        </SELECT>
        </DIV></TD>
        <TD><DIV CLASS="toolfont">
          <SELECT NAME="File">
            <SCRIPT LANGUAGE="JavaScript">localeArea.printOptions()</SCRIPT>
          </SELECT>
        </DIV></TD>
      </TR>
      </TABLE>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD COLSPAN="3"><DIV CLASS="thead"><B>Time Servers</B></DIV></TD>
      </TR>

      <TR $cb>
        <TD COLSPAN="3"><DIV CLASS="nbody">
          NTP is the Network Time Protocol and is used to keep your machines
          system clock in sync with the "official" time as defined various
          atomic clocks.  Below you are asked to either select or enter
          <B>three</B> NTP servers.  It is very important that you have three
          for the sake of reliability and accuracy.  Please select (from the
          pre-define list) or enter (if you have local time servers) three
          servers below.

          <P>If you only wish to have one or two servers, please enter
          duplicates so that all three are filled out.
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="3"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$ntp_1_HELP</B></DIV></TD>
        <TD><DIV CLASS="toolfont">$ntp_SELECT_1</DIV></TD>
      </TR>
      <TR $cb>
        <TD>&nbsp;</TD>
        <TD><INPUT TYPE="TEXT" NAME="ntpinput_1" SIZE="20"></TD>
      </TR>

      <TR $cb> <TD COLSPAN="3"> &nbsp; </TD> </TR>


      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$ntp_2_HELP</B></DIV></TD>
        <TD><DIV CLASS="toolfont">$ntp_SELECT_2</DIV></TD>
      </TR>
      <TR $cb>
        <TD>&nbsp;</TD>
        <TD><INPUT TYPE="TEXT" NAME="ntpinput_2" SIZE="20"></TD>
      </TR>

      <TR $cb> <TD COLSPAN="3"> &nbsp; </TD> </TR>


      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$ntp_3_HELP</B></DIV></TD>
        <TD><DIV CLASS="toolfont">$ntp_SELECT_3</DIV></TD>
      </TR>
      <TR $cb>
        <TD>&nbsp;</TD>
        <TD><INPUT TYPE="TEXT" NAME="ntpinput_3" SIZE="20"></TD>
      </TR>

      <TR $cb> <TD COLSPAN="3"> &nbsp; </TD> </TR>

      </TABLE>
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="toolfont">
      <INPUT TYPE="SUBMIT" NAME="save" VALUE="Save and Proceed">
    </DIV></TD>
  </TR>
  </TABLE>
  </FORM>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("step_01.cgi");

