#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: step_03.cgi,v 1.3 2003/03/03 14:11:11 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  # Import our local RPM database and library subroutines.
  use RPM::Database '%RPM';
  require "INITCONFIG-lib.pl";

  # Define local variables.
  $admin_email_HELP = &hlink("Administrator Email", "admin_email");
  $trusted_iface_HELP = &hlink("Trusted Interface",   "trusted_iface");
  $untrusted_iface_HELP = &hlink("Untrusted Interface", "untrusted_iface");

  # Print standard header.
  &header("Initial Configuration :: Email, Firewall, and Service Configuration (3/3)", 0);

  # Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_step_03.cgi" METHOD="POST">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>
      Initial Configuration :: Email, Firewall, and Service Configuration
    </B></DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Email Configuration</B></DIV></TD>
      </TR>

      <TR $cb>
        <TD COLSPAN="2"><DIV CLASS="nbody">
          Please enter the email address where system reports should be sent
          to.  Several reports run nightly which the system administrator
          should review.  These reports will be sent to this address.
        </TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$admin_email_HELP</B></DIV></TD>
        <TD><DIV CLASS="toolfont">
          <INPUT TYPE="TEXT" NAME="admin_email" SIZE="30">
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

EOF

  ###
  ###  Only display firewall stuff if we have iptables installed.
  ###
  if ($RPM{'iptables'}) {
    print <<EOF;
      <!-- Firewall Configuration -->
      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Firewall Configuration</B></DIV></TD>
      </TR>

      <TR $cb>
        <TD COLSPAN="2"><DIV CLASS="nbody">
EOF


  ###  Only display firewall info if we have more then one interface.
  if (&NumInterfaces() > 1) {
    print <<EOF;
          Since you have chosen to install the firewall package, you must select
          which interface is to be "trusted" and which is to be "untrusted."
          The trusted interface sits on <I>inside</I> of your firewall whereas
          the untrusted interface sits on the <I>outside</I> of your fireall and
          provides your Internet connectivity.
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD WIDTH="50%"><DIV CLASS="nbody"><B>$trusted_iface_HELP</B></DIV></TD>
        <TD WIDTH="50%"><DIV CLASS="toolfont">
          <SELECT NAME="trusted_iface">
            <OPTION VALUE="NULL">Please Select</OPTION>
EOF


  ###  Display all the REAL interfaces.
  foreach my $i (&GetInterfaces()) {
    next if ($i->{'virtual'});
    print "            <OPTION VALUE=\"$i->{'iface'}\">";
    print "$i->{'iface'} ($i->{'address'})</OPTION>\n";
  }


  ###  More HTML.
  print <<EOF;
          </SELECT>
        </DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$untrusted_iface_HELP</B></DIV></TD>
        <TD><DIV CLASS="toolfont">
          <SELECT NAME="untrusted_iface">
            <OPTION VALUE="NULL">Please Select</OPTION>
EOF


  ###  Display all the REAL interfaces.
  foreach my $i (&GetInterfaces()) {
    next if ($i->{'virtual'});
    print "            <OPTION VALUE=\"$i->{'iface'}\">";                           print "$i->{'iface'} ($i->{'address'})</OPTION>\n";
  }
  

  ###  More HTML.
  print <<EOF;
          </SELECT>
        </DIV></TD>
      </TR>

EOF
  }

  ###  We're on a one-interface machine, so only ask for a subset of the info.
  else {
    my ($iface);

    ###  We only have one, so get it's name.
    foreach my $i (&GetInterfaces()) {
      next if ($i->{'virtual'}); $iface = $i->{'iface'}
    }

    ###  Now print the HTML.
    print <<EOF;
          Your machine only has one interface active, so host-only firewalling
          will be set up on this machine.  If you add an (or activate) and
          interface at a later time, you can configure it in the <B>Firewall
          Setup</B> module.

          <INPUT TYPE="HIDDEN" NAME="single_iface" VALUE="1">
          <INPUT TYPE="HIDDEN" NAME="untrusted_iface" VALUE="$iface">
        </DIV></TD>
      </TR>
EOF
  }


  ###  More HTML.
  print <<EOF;

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
EOF
  }


  ###  More HTML.
  print <<EOF;
  <!-- Service Configuration -->
      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Service Configuration</B></DIV></TD>
      </TR>

      <TR $cb>
        <TD COLSPAN="2"><DIV CLASS="nbody">
          Below you are asked to define what services you would like active on
          this machine.  Currently enabled services are already checked; uncheck
          them to disable them.
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD WIDTH="50%"><DIV CLASS="nbody"><B>Service Name</B></DIV></TD>
        <TD WIDTH="50%"><DIV CLASS="nbody"><B>Enable Service?</B></DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"><HR NOSHADE WIDTH="75%" ALIGN="LEFT"></TD> </TR>
EOF


  ###  Display all our services, selected if they currently are.
  foreach my $s (@SERVICES) {
    my ($SELECTED);

    ###  Don't try to configure services we don't have installed.
    next if (! -f "/etc/init.d/$s->{'init'}");

    ###  Special case for xinetd.
    if ($s->{'init'} eq "xinetd") {
        $SELECTED = "CHECKED" if (&isXinetdServiceActive($s->{'port'}));
    }
    else {
        $SELECTED = "CHECKED" if (&isServiceActive($s->{'init'}));
    }

    print <<EOF;
      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$s->{'name'}</B></DIV></TD>
        <TD><DIV CLASS="tbody">
          <INPUT TYPE="CHECKBOX" NAME="activate_$s->{'init'}" $SELECTED>
        </DIV></TD>
      </TR>

EOF
  }


  ###  More HTML.
  print <<EOF;
      </TABLE>
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>


  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="toolfont">
      <INPUT TYPE="SUBMIT" NAME="save" VALUE="Save and Proceed">
    </DIV></TD>
  </TR>
  </TABLE>
  </FORM>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("step_02.cgi");

