#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: summary.cgi,v 1.2 2002/05/16 19:16:13 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require "INITCONFIG-lib.pl";

  ###  Setup local variables.
  # my ($root_help_1, $root_help_2);
  # my ($webtool_help_1, $webtool_help_2);

  ###  Define local variables.
  # $root_help_1     =  &hlink("Enter Root Password",     "root_pass_1");


  ###  Print the usual header.
  &header("Initial Configuration :: System Summary and Reboot", 0);


  ###  Now print the pretty HTML.
  print <<EOF;
<P><CENTER>
  <FORM ACTION="do_reboot.cgi" METHOD="POST">
  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="620">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>
      Initial Configuration :: System Summary and Reboot
    </B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Congratuations, your EnGarde Secure Linux machine is now successfully
      configured.  Below is an outline of your current configuration.  You are
      suggested to print this page and save it for future reference.

      <P>You must now reboot your machine, by clicking the button below, for the
      changes to take effect.
    </TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Network Settings</B></DIV></TD>
      </TR>

EOF


  foreach my $i (&GetInterfaces()) {
    my ($hostname);
    next if ($i->{'virtual'});

    $hostname = gethostbyaddr(pack("C4", split /\./, $i->{'address'}), 2);
    $hostname = "Undefined" if (! $hostname);

    print <<EOF;
      <TR $cb>
        <TD WIDTH="30%"><DIV CLASS="nbody"><B>Interface</B></DIV></TD>
        <TD><DIV CLASS="nbody">$i->{'iface'}</DIV></TD>
      </TR>
      <TR $cb>
        <TD><DIV CLASS="nbody"><B>Address</B></DIV></TD>
        <TD><DIV CLASS="nbody">$i->{'address'}</DIV></TD>
      </TR>
      <TR $cb>
        <TD><DIV CLASS="nbody"><B>Hostname</B></DIV></TD>
        <TD><DIV CLASS="nbody">$hostname</DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
EOF
  }


  ###  More HTML.
  print <<EOF;

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Service Configuration</B></DIV></TD>
      </TR>

EOF


  foreach my $s (@SERVICES) {
    my ($TEXT);

    ###  Don't try to configure services we don't have installed.
    next if (! -f "/etc/init.d/$s->{'init'}");

    $TEXT = "<FONT COLOR=\"RED\">Disabled</FONT>";

    if (($s->{'init'} eq "xinetd") && &isXinetdServiceActive($s->{'port'})) {
      $TEXT = "<FONT COLOR=\"GREEN\">Active</FONT>";
    }
    elsif (($s->{'init'} ne "xinetd") && &isServiceActive($s->{'init'})) {
      $TEXT = "<FONT COLOR=\"GREEN\">Active</FONT>";
    }

    print <<EOF;
      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$s->{'name'}</B></DIV></TD>
        <TD><DIV CLASS="nbody"><B>$TEXT</B></DIV></TD>
      </TR>

EOF
  }


  ###  More HTML.
  print <<EOF;

      </TR>
      </TABLE>
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS="toolfont">
      <INPUT TYPE="SUBMIT" NAME="reboot" VALUE="Reboot System">
    </DIV></TD>
  </TR>
  </TABLE>
  </FORM>
</CENTER><P>
EOF


  ###  Print the usual footer.
  &ryanFooter("index.cgi");

